#set -x
#
#SUPERPATCH MAKER
#FIRST EXTRACT SOURCE AND PATCH WOLFMAME ONLY
#THEN COPY SRC to ORIG.SRC
#THEN APPLY WOLFMAME PATCHES AND CHANGES THEN MAKE SUPER PATCH 
#find mames \( -name *.rej -o -name *.orig \) -exec rm -f {}  \; 
#diff -Nru mames/orig.SRC mames/src>abc.diff
#for b in `grep ^+++ abc.diff |sed 's/[\t]/ /g'|cut -d' ' -f2 ` ; do
#  sed 's/[\r]//' < "$b" > /tmp/crstrip.$$
#  mv /tmp/crstrip.$$ "$b"
#done
#for b in `grep ^--- abc.diff |sed 's/[\t]/ /g'|cut -d' ' -f2 ` ; do
#  sed 's/[\r]//' < "$b" > /tmp/crstrip.$$
#  mv /tmp/crstrip.$$ "$b"
#done
#diff -Nru mames/orig.SRC mames/src>abc.diff
#
if [ "$OSTYPE" = "linux-gnu" ] ; then
	SDL=1
else
	SDL=0
fi
if [ "$SDL" = 1 ] ; then
	MESSBASE=/mnt/media/games
	if [ ! -d "$MESSBASE" ] ; then
		MESSBASE=/cygdrive/d/games
	fi
	MESSLOCAL=/tmp
else
	MESSBASE=l:/games
	if [ ! -d "$MESSBASE" ] ; then
		MESSBASE=d:/games
		MESSLOCAL=d:/games
	else
		MESSBASE=l:/games
		MESSLOCAL=l:/games
	fi
fi
ARCHIVEPATCHDIR=$HOME/sdlbuild
DOWNLOADDIR=/mnt/d/dl

if [ ! -x /usr/bin/patch ] ; then
	echo must have /usr/bin/patch
	exit
fi

#to rename an old diffset to a new one, this will copy stuff that will be
# overwritten by the new versions when we get them
download() {
	if [ "$2" = "" ] ; then
		mainfile="`basename "$1"`"
	else
		mainfile="$2"
	fi
	if [ ! -f "$mainfile" ] ; then
		lynx -source "$1" > "$mainfile"
	fi
}
download http://messui.the-chronicles.org/messui"$2"s.rar messui0"$2"s.rar

buildenv() {
if [ "$SDL" = 1 ] ; then
	:
else
	#extract mingw into c:
	if [ "$1" -ge 143 ] ; then
		"7z" -ms=on -y x -oc:\\ $MESSBASE/mingw-mame-w32-20110519.exe
		#extract dx already included
	elif [ "$1" -ge 137 ] ; then
		"7z" -ms=on -y x -oc:\\ $MESSBASE/mingw-mame-w32-20100102.exe
		#extract dx80 over mingw
		unzip -o $MESSBASE/dx80_mgw.zip -d c:/mingw64-w32
	else
		#"7z" -y x -oc:\\mingw\\ $MESSBASE/mingw-mame-20070810.exe
		"7z" -y x -oc:\\ $MESSBASE/mingw-mame-20060210.exe
		#extract dx80 over mingw
		unzip -o $MESSBASE/dx80_mgw.zip -d c:/mingw
	fi
fi
}

prepatch() {
cd "$1"
shift
for a in $* ; do
	if [ ! -f "$MESSBASE/$a" ] ; then
		echo ------------------------
		echo patch $MESSBASE/$a not there -0-0-0-0-0-0-0-0-0-0-0-0-0-0-
		echo ------------------------
		continue
	fi
	echo ------------------------------PATCHING $a
	# first crstrip the files in the patch dir
	for b in `grep ^+++ "$MESSBASE/$a" |sed 's/[\t]/ /g'|cut -d' ' -f2|cut -d/ -f2-` "$MESSBASE/$a"; do
		sed 's/[\r]//' < "$b" > /tmp/crstripp.$$
		mv /tmp/crstripp.$$ "$b"
	done
done
rm -f /tmp/crstripp.$$
cd ..
}

patchit() {
#return
cd $MESSLOCAL/"$1"
pwd

# may not need to do this lowercase renaming anymore but it cant hurt
mv src/emu/machine/RP5H01.c  rp5h01.c
mv rp5h01.c src/emu/machine

for a in ${PATCHES} ; do
	if [ ! -f "$MESSBASE/$a" ] ; then
		echo ------------------------
		echo patch $MESSBASE/$a not there -0-0-0-0-0-0-0-0-0-0-0-0-0-0-
		echo ------------------------
		continue
	fi
	echo ------------------------------PATCHING $a
	# first crstrip the files in the patch dir
	for b in `grep ^+++ "$MESSBASE/$a" |sed 's/[\t]/ /g'|cut -d' ' -f2|cut -d/ -f2-` "$MESSBASE/$a"; do
		sed 's/[\r]//' < "$b" > /tmp/crstrip.$$
		mv /tmp/crstrip.$$ "$b"
	done
	rm -f /tmp/crstrip.$$
	#if SDL and version ge 144 skip winui patches
	if [ "$SDL" = 1 -a "$2" -ge 144 ] ; then
		awk 'BEGIN {NONO=0;} /^diff.*winui/ { NONO=1; } /^diff/ && ! /.*winui.*/ {NONO=0;} {if (NONO==0) {print;} }' < $MESSBASE/$a | /usr/bin/patch -l -p1 
	else
		/usr/bin/patch -l -p1 < $MESSBASE/$a
	fi
done

# patch the version message
oldver=$[$2-1]
#sed -e s/0."$oldver ".*\;/0.$2wolf`date +%y%m%d.%H%M`"\";"/ -e s/0."$2 ".*\;/0.$2wolf`date +%y%m%d.%H%M`"\";"/ < src/version.c > src/v.c
#dont have to do this no more with the [W] in there
#sed -e s/0."$oldver "/0.$2wolf" "/ -e s/0."$2 "/0.$2wolf" "/ < src/version.c > src/v.c
#mv -f src/v.c src/version.c

cd ..
}

unpack() {
if [ "$1" = "" -o "$2" = "" ] ; then
	echo must use both parameters to UNPACK
	exit
fi

if [ "$SDL" = 1 ] ; then
	if [ $2 -gt 136 ] ; then
		if ! 7za -y x -o$MESSLOCAL/"$1" $MESSBASE/mame0"$2"s.exe ; then
			echo CANT EXECUTE 7zip install it
			exit 1
		fi
		unzip -o $MESSBASE/mess0"$2"s.zip -d $MESSLOCAL/"$1"
		if [ ! -f ~/sdlbuild/sdlmess0"$2".zip ] ; then
			echo
			echo dont build archive source here do it in archive command
			echo
		fi
	else
		unzip -o $MESSBASE/sdlmess0"$2".zip  -d$MESSLOCAL
	fi
else
	mkdir -p $MESSLOCAL/"$1"
	#dont need to extract mame anymore
	#extract mame into $MESSBASE/"$1"
	##"7z" -y x -o$MESSLOCAL/"$1" $MESSBASE/mame0"$2"s.exe
	#"7z" -y x -od:\\games\\$DIRECTORY $MESSBASE/mame0"$2"s.exe

	unzip -o $MESSBASE/mess0"$2"s.zip -d $MESSLOCAL/"$1"
	if [ $2 -ge 145 ] ; then
		# extracting into src thru temp dir in rar file
		cd $MESSLOCAL/"$1"
		rar32 -y x $MESSBASE/messui0"$2"s.rar
	elif [ $2 -ge 144 ] ; then
		# extracting into src thru temp dir in rar file
		cd $MESSLOCAL/"$1"
		mkdir "messui src-zip"
		mv src "messui src-zip"
		rar32 -y x $MESSBASE/messui0"$2"s.rar
		mv "messui src-zip"/src .
	fi
fi

patchit "$1" "$2"
}

makesdlpatches() {
	pushd .
	cd $MESSBASE
	rm -rf sdlmame0$1
	mkdir sdlmame0$1
	if [ ! -f "$ARCHIVEPATCHDIR/sdlmame0$1.zip" ] ; then
		7za -y x -osdlmame0$1 mame0"$1"s.exe
		prepatch sdlmame0$1 $WOLFPATCHES
		zip -9rm $ARCHIVEPATCHDIR/sdlmame0$1.zip sdlmame0$1
		mv sdlmame0$1 sdlmess0$1
		unzip -o mess0$1s.zip -dsdlmess0$1
		prepatch sdlmess0$1 $PATCHES
		zip -9rm $ARCHIVEPATCHDIR/sdlmess0$1.zip sdlmess0$1
	# might be able to auto upload if i can get the password in clear text
echo	ncftpput -f $MESSBASE/ftpwolf.cfg /emulators.homeactionreplay.org/sdlmame-mirror $ARCHIVEPATCHDIR/sdlmame0$1.zip
echo	ncftpput -f $MESSBASE/ftpwolf.cfg /emulators.homeactionreplay.org/sdlmess-mirror $ARCHIVEPATCHDIR/sdlmess0$1.zip
	fi
	cat $WOLFPATCHES > $ARCHIVEPATCHDIR/sdlmame0$1-wolf.diff
	if [ "$SDL" = 1 -a "$1" -ge 144 ] ;  then
		cat $PATCHES | awk 'BEGIN {NONO=0;} /^diff.*winui/ { NONO=1; } /^diff/ && ! /.*winui.*/ {NONO=0;} {if (NONO==0) {print;} }' > $ARCHIVEPATCHDIR/sdlmess0$1-wolf.diff
	else
		cat $PATCHES > $ARCHIVEPATCHDIR/sdlmess0$1-wolf.diff
	fi
echo	ncftpput -f $MESSBASE/ftpwolf.cfg /emulators.homeactionreplay.org/sdlbuild $ARCHIVEPATCHDIR/sdlmess0$1-wolf.diff
echo	ncftpput -f $MESSBASE/ftpwolf.cfg /emulators.homeactionreplay.org/sdlbuild $ARCHIVEPATCHDIR/sdlmame0$1-wolf.diff
	popd
}

archive() {
if [ "$SDL" = 1 ] ; then
	makesdlpatches $2
else
	cd $MESSLOCAL/"$1"
	rm -rf hash hlsl
	mkdir hash hlsl
	#hash files must be put it two places
	cp $MESSBASE/mess/dist.wolf/hash/* hash
	cp $MESSBASE/mess/dist.wolf/hlsl/* hlsl

	cp $MESSBASE/wolfmess"$2".txt wolfmess"$2".txt
	rm -f ../wolfmess"$2".exe
	# must be the C: version because it has self extration capabilities
	"c:/Program Files/7-Zip/7z" a -sfx $MESSBASE/wolfmess"$2" mess.exe messui.exe hash wolfmess"$2".txt
	rm -rf hash
	cd $MESSBASE
	rm -f wolfmess"$2"-src.zip
	zip -9 wolfmess"$2"-src ${PATCHES} sdl$2.diff messcompile.sh wolfmess"$2".txt messui0"$2"s.rar
fi
}

build() {

if [ "$1" = "" -o "$2" = "" ] ; then
	echo must use both parameters to BUILD
	exit
fi

if [ "$SDL" = 1 ] ; then
cd $MESSLOCAL
else
cd $MESSLOCAL/"$1"
fi

if [ "$3" = "" ] ; then
	echo UNPACKING NOW
	unpack "$1" "$2"
fi

#export PATH=/cygdrive/c/mingw/bin:$PATH
export PATH=/cygdrive/c/mingw64-w32/bin:$PATH

if [ `cat /proc/cpuinfo |egrep processor.*:|wc -l` -gt "1" ] ; then
	MAKEOPTS="$MAKEOPTS -j2"
#j3 will make windows compiles fail
#	MAKEOPTS="$MAKEOPTS -j3"
	echo USING CPU PROC $MAKEOPTS PROCESSORS
fi

#MAKEOPTS="$MAKEOPTS DEBUG=1"
#MAKEOPTS="$MAKEOPTS SYMBOLS=1 -W mess.exe "

###TOMAKE#MAKE######make
if [ "$SDL" = 1 ] ; then

cd "$MESSLOCAL"/sdlmess0$2
if [ $2 -le 136 ] ; then
	# make the 32biter
	# cant use SYMBOLS=1 for 32 bit :( on 64 bit, but will make w/no symbols
	#make -f makefile.sdl $MAKEOPTS X86_MIPS3_DRC= X86_PPC_DRC= 
	make -f makefile.sdl $MAKEOPTS PTR64=1 PM= AMD64=1 
else
	#post sdlmess compiling
	make $MAKEOPTS PTR64=1 PM= AMD64=1 TARGET=mess
fi
else
cd "$MESSLOCAL"/"$1"
	#need to clean before changing build options
#	make TARGET=mess $MAKEOPTS AMD64=1 PM=
#DEBUG and symbols does not work
	make TARGET=mess $MAKEOPTS OSD=winui
	#also have to make the normal exe
#	make TARGET=mess $MAKEOPTS 

fi

cd  ..

}

compile() {
build "$1" "$2" compile
}

reunpack() {
rm -rf $MESSLOCAL/"$1"
if mkdir $MESSLOCAL/"$1" ; then
	unpack "$1" "$2"
fi
}

rebuild() {
rm -rf $MESSLOCAL/"$1"
if mkdir $MESSLOCAL/"$1" ; then
	build "$1" "$2"
fi
}

if [ "$2" = "" ] ; then
	echo messcompile.sh COMMAND VERSION [DIRECTORY]
	echo example: messcompile.sh build 113 mames.113
	echo default DIRECTORY is "mames"
	echo
	echo COMMANDS: buildenv, unpack, compile, build, rebuild, archive, download, newdist, clean
	echo
	echo VERSION CAN BE: 113 114 etc...
	echo
	echo buildenv: builds the mingw compile environment
	echo buildenv: expects files dx80_mgw.zip and mingw-mame-20060210.exe
	echo patch: just patches
	echo unpack: just extracts source and patches
	echo compile: expects a build or rebuild to have already been done
	echo clean: same as compile but cleans instead of compiles
	echo build: extracts source over existing DIRECTORY, patches, then compiles
	echo rebuild: removes DIRECTORY, then performs build
	echo archive: creates wolfmessVERSION-src.zip and wolfmessVERSION.exe
	echo makesdlpatches: creates mess and mame patches for sdlbuild
	echo download: \(calls reunpack\) downloads the source needed for  wolfmessVERSION
	echo newdist: \(calls DL\!\) use first to turn wolfmessVERSION-1 into woflmessVERSION
	exit
fi
if [ "$SDL" = 1 ] ; then
	DIRECTORY=sdlmess0"$2"
	SDLtext=sdl
else
	DIRECTORY=mames
	if [ ! "$3" = "" ] ; then
		DIRECTORY="$3"
	fi
	SDLtext=
fi

if [ "$1" -gt 0 ] 2>/dev/null ; then
	echo swap parameters, usage: messcompile.sh COMMAND VERSION
	exit 1
fi
if [ "$2" -ge 146 ] ; then
	INPVIEWVERSION=18
elif [ "$2" -ge 142 ] ; then
	INPVIEWVERSION=17
elif [ "$2" -ge 140 ] ; then
	INPVIEWVERSION=16
elif [ "$2" -ge 137 ] ; then
	INPVIEWVERSION=15
elif [ "$2" -ge 126 ] ; then
	INPVIEWVERSION=14
elif [ "$2" -ge 125 ] ; then
	INPVIEWVERSION=13-src
else
	INPVIEWVERSION=12-src
fi

#WOLFPATCHES="wolf$2.diff dipports$2.diff inpview$INPVIEWVERSION-$2.diff"
#nomore dipports mame got wise
WOLFPATCHES="wolf$2.diff inpview$INPVIEWVERSION-$2.diff"
PATCHES="$WOLFPATCHES wolfmess$2.diff"

# comment for NON DEVEL build, before full build
#PATCHES="${PATCHES} chad${SDLtext}mess$2.diff"

if [ "$SDL" = 1 ] ; then
	PATCHES="${PATCHES} sdl$2.diff"
	# dont need to do this sdlmame just should build its own platform
	#	WOLFPATCHES="${WOLFPATCHES} sdl$2.diff"
fi

case "$1" in
"makesdlpatches")
echo param $2
	echo JUST making patches
	makesdlpatches $2
	;;
"buildenv")
	echo BUILDING compile ENVIRONMENT FIRST
	buildenv $2
	;;
"patch")
	echo JUST PATCHING
	patchit $DIRECTORY $2
	;;
"unpack")
	echo EXTRACTING, AND PATCHING
	unpack $DIRECTORY $2
	;;
"preunpack")
	echo EXTRACTING, AND PATCHING with out wolfmess changes
	PATCHES=`echo $PATCHES|sed 's/wolfmess[^ ]//'`
	reunpack $DIRECTORY $2
	;;
"compile")
	echo BUILDING
	compile $DIRECTORY $2
	;;
"clean")
	echo BUILDING
	MAKEOPTS="$MAKEOPTS clean"
	compile $DIRECTORY $2
	;;
"build")
	echo EXTRACTING, PATCHING, AND BUILDING
	build $DIRECTORY $2
	;;
"rebuild")
	echo REMOVING, EXTRACTING, PATCHING, AND BUILDING
	rebuild $DIRECTORY $2
	;;
"archive")
	echo ARCHIVING WOLFMESS
	archive $DIRECTORY $2
	;;
"download")
	cd $MESSBASE
	if [ "$SDL" = 1 ] ; then
		if [ $2 -gt 136 ] ; then
			echo sdlmess not need to download
			if [ ! -f mame0"$2"s.exe -o ! -f mess0"$2"s.zip ] ; then
				echo need to redowload dos source
				exit 1
			fi
		elif [ ! -f sdlmess0"$2".zip ] ; then
			echo download http://rbelmont.mameworld.info/sdlmess0"$2".zip
			echo downlaoding this with lynx doesnt work, you have to firefox it
			echo
			echo close all firefoxes and download windows before proceding
			firefox http://rbelmont.mameworld.info/sdlmess0"$2".zip
			echo 
			echo press any key when downloaded 
			pwd
			read qqq
			mv $DOWNLOADDIR/sdlmess0"$2".zip .
		fi
		# dont need to move antyhign the patch dirs work in place
		#for a in *$[$2-1]* ; do cp -f "$a" "`echo $a|sed s/$[$2-1]/$2/`" ;done
	else
		if [ $2 -ge 145 ] ; then
			download http://messui.the-chronicles.org/messui"$2"s.rar messui0"$2"s.rar
		elif [ $2 -ge 144 ] ; then
			download http://messui.the-chronicles.org/messui0"$2"s.rar
		fi
		if [ $2 -le 136 ] ; then
			download http://rbelmont.mameworld.info/sdlmess0"$2".zip
		fi
		# %3a is for :
		download 'http://mess.redump.net/_media/downloads%3amess0'"$2"s.zip mess0"$2"s.zip
		#echo download 'http://mess.redump.net/_media/downloads:mess0'"$2"s.zip
		#download 'http://mamedev.org/downloader.php?file=releases/mame0'"$2"s.exe
		if [ ! -f "mame0$2s.exe" ] ; then
			echo download 'http://mamedev.org/downloader.php?file=releases/mame0'"$2"s.exe
			echo you must download ONE FILE manually to l:/games before continuing
			read qqq
		fi
		#test
		if ! 7za t "mame0$2s.exe" > /dev/null ; then
			echo "mame0$2s.exe" is not a valid archive
			exit
		fi
		zip -d mess0"$2"s.zip artwork/*
		#download http://www.mess.org/files/mess0"$2"s.zip
		download http://wolfmame.marpirc.net/inpview$INPVIEWVERSION-"$2".zip
		unzip -o inpview$INPVIEWVERSION-"$2".zip
		download http://wolfmame.marpirc.net/wolf"$2".zip
		unzip -o wolf"$2".zip
	fi
	#tools
	#download http://mamedev.org/tools/mingw-mame-20070810.exe
	##download http://mamedev.org/tools/mingw-mame-20060210.exe
	#download http://alleg.sourceforge.net/files/dx80_mgw.zip
	#check for bad patches (there will be some!)
	echo EXTRACTING, AND PATCHING
	#preunpack "$2" "$DIRECTORY"."$2"
	reunpack $DIRECTORY $2
	;;
"repatch")
	echo EXTRACTING, AND PATCHING
	reunpack $DIRECTORY $2
	;;
"newdist")
	if [ "$SDL" = 1 ] ; then
		echo perform NEWDIST on patchdir in dos to copy over old version files to new
	else
		pushd . 
		cd $MESSBASE
		for a in *$[$2-1]* ; do 
			#dont copy exe or zip files they will be downloaded
			if [ "$a" = "`echo $a|sed -e 's/.exe$//' -e 's/.zip$//'`" ] ; then
				cp -f "$a" "`echo $a|sed s/$[$2-1]/$2/`" 
			fi
		done
#		rm -f *"$2"*.zip *"$2"*.exe
		$0 download "$2" "$DIRECTORY" 
		popd .
	fi
	;;
*)
	echo UNKNOWN COMMAND for messcompile: "$1"
	echo possible: newdist, download, compile, build, rebuild, clean
	;;
esac

